jsdom = require 'mocha-jsdom'
chai = require 'chai'
chai.should()


describe 'SimplePlugin', (done) ->


	beforeEach (done) ->
		document = jsdom.jsdom("<html>")
		window = document.parentWindow
		$ = global.jQuery = require('jquery')(window)

		Plugin = require '../src/plugin'

		class Simple extends Plugin

			blink: -> return "I'm blinking yo!"

		Simple.register()


	it 'creates a plugin'
		# - $ has `Simple`

	it 'can execute plugin methods'
		# - create fake html document
		# - initiate $.Simple() on an element
		# - expect $.Simple('blink') to return "I'm blinking yo!"

	it 'knows about itself from data attribute'
		# - create fake html document
		# - initiate $.Simple() on an element
		# - test that the $(element).data('Simple')
		#   is an instance of the Simple class

	it 'subclasses inherits options properly'
		# - create fake html document
		# - initiate $.Simple({foo: 'bar'}) on an element
		# - test that $(element).data('Simple').options contains :
		# 		foo: 'bar'

	it 'destroys itself properly'
		# - create fake html document
		# - initiate $.Simple({foo: 'bar'}) on an element
		# - test that the $(element).data('Simple')
		#   is an instance of the Simple class
		# - trigger $(element).trigger 'destroyed.Simple'
		# - ensure that $(element).data('Simple') is undefined or null

